// flag_stealer.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"

BZ_GET_PLUGIN_VERSION

class FlagStealer: public bz_EventHandler
{
public:
  FlagStealer() {}

  virtual void process(bz_EventData* eventData);

  virtual bool autoDelete(void) { return false; }

};

FlagStealer flag_stealer;

BZF_PLUGIN_CALL int bz_Load ( const char* /*commandLine*/ )
{
  bz_debugMessage(4,"flag_stealer plugin loaded");

  bz_registerEvent(bz_ePlayerDieEvent,&flag_stealer);

  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
  bz_removeEvent(bz_ePlayerDieEvent,&flag_stealer);

  bz_debugMessage(4,"flag_stealer plugin unloaded");
  return 0;
}

void FlagStealer::process(bz_EventData* eventData)
{
  if(eventData->eventType != bz_ePlayerDieEvent)
    return;

  bz_PlayerDieEventData* deathRecord = (bz_PlayerDieEventData*)eventData;
  bz_PlayerRecord* killerData = bz_getPlayerByIndex(deathRecord->killerID);
  if(killerData && killerData->wins - killerData->losses >= -4
    && killerData->currentFlag != "SH" && killerData->currentFlag != "ID" )
    bz_removePlayerFlag(deathRecord->killerID);
}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

